/*
Ox program for  lage figurene til de ulike Phillipskurvespesifikasjonene
i kapittel 3

*/

#include <oxstd.h>
#import <database>	 //gjr at vi kan bruke databasefunksjoner for  hndtere GiveWinfiler enkelt
#include <oxdraw.h>	 // for  lage figurer
//#include <oxfloat.h> // for  kunne bruke "missing values"

main()
{
decl dbase, P, U, Inf, Y, X, b, fit, pred, preds, predniv, prednivs;    

//lager database av datasettet
	dbase = new Database();
	dbase.LoadIn7("Phillipskurve kap3.in7");
	dbase.Info();

// Lager inflasjon "Inf"
	//henter konsumprisindeksen
	P = dbase.GetVar("P");
	U =	dbase.GetVar("U");
	//lager inflasjon
	Inf = 100.*diff0(P,1, .NaN)./lag0(P,1, .NaN);
	print("Inf og U", Inf~U);
	//m kutte ut frste observasjon
	Inf = dropr(Inf,0);
	U = dropr(U,0);
	println("Inf og U fra og med 2. observasjon");
	print("%c",{"Inf","U"},Inf~U);

//*************estimerer modellene*************

	println("*****************Estimerer liner modell********************");
	Y = Inf;
	X = U;
	
	olsc(Y,1~X,&b);							//lagrer parameterestimatene i vektoren b										
	print( "%c", {"estimat"},
	           "%r", {"konstantledd", "stigningstall"}, b );


// Lager figur
	SetDraw(SET_DEFAULT);							//resets defaults
	SetDraw(SET_XYSTYLE,1);							//labels along axes
	DrawX(0,Y',X');
	DrawAxisAuto(0,TRUE);
	DrawAdjust(ADJ_AXISLINE,FALSE,-1,-1,-1); //ingen linje nr Y=0
//tegner inn den estimerte modellen
	DrawXMatrix(0,b'*(1~X)',"$Y$",X',"$X$",0,1);	
	DrawAdjust(ADJ_AXISLABEL,1,0,-1,1);
	SetDrawWindow("lin-linreg");
	ShowDrawWindow();
//	SaveDrawWindow("linlinreg.eps");

	println("*********************log-log spesifikasjon******************");
	
	olsc(log(Y),1~log(X),&b);							//lagrer parameterestimatene i vektoren b										
	print( "%c", {"estimat"},
	           "%r", {"konstantledd", "stigningstall"}, b );


// Lager figur
	SetDraw(SET_DEFAULT);							//resets defaults
	SetDraw(SET_XYSTYLE,1);							//labels along axes
	DrawX(0,log(Y)',log(X)');
	DrawX(1,Y',X');
	
	DrawAxisAuto(0,TRUE);
	DrawAdjust(ADJ_AXISLINE,FALSE,-1,-1,-1); //ingen linje nr Y=0
	//estimert modell
	pred = (1~log(X))*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	preds = sortbyc(pred~log(X),1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
	//den estimerte modellen i nivvariabler
	predniv = exp((1~log(X))*b);
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	prednivs = sortbyc(predniv~X,1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
		
	//tegner inn de estimerte modellene
	DrawXMatrix(0,preds[][0]',"$lnY$",preds[][1]',"$lnX$",0,1);	
	DrawXMatrix(1,prednivs[][0]',"$Y$",prednivs[][1]',"$X$",0,1);
	DrawAdjust(ADJ_AXISLABEL,1,0,-1,1);
	DrawAdjust(ADJ_AREAMATRIX,1,2,1,-1);  // 1x2 figur   
	SetDrawWindow("log-logreg");
	ShowDrawWindow();
//	SaveDrawWindow("loglogreg.eps");

	println("*********************log-lin spesifikasjon******************");
	
	olsc(log(Y),1~(X),&b);							//lagrer parameterestimatene i vektoren b										
	print( "%c", {"estimat"},
	           "%r", {"konstantledd", "stigningstall"}, b );


// Lager figur
	SetDraw(SET_DEFAULT);							//resets defaults
	SetDraw(SET_XYSTYLE,1);							//labels along axes
	DrawX(0,log(Y)',X');
	DrawX(1,Y',X');
	DrawAxisAuto(0,TRUE);
	DrawAdjust(ADJ_AXISLINE,FALSE,-1,-1,-1); //ingen linje nr Y=0
	//den estimerte modellen
	pred = (1~X)*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	preds = sortbyc(pred~X,1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
	//den estimerte modellen i nivvariabler
	predniv = exp((1~X)*b);
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	prednivs = sortbyc(predniv~X,1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
		
	//tegner inn den estimerte modellen
	DrawXMatrix(0,preds[][0]',"$lnY$",preds[][1]',"$X$",0,1);
	DrawXMatrix(1,prednivs[][0]',"$Y$",prednivs[][1]',"$X$",0,1);	
	DrawAdjust(ADJ_AXISLABEL,1,0,-1,1);
	DrawAdjust(ADJ_AREAMATRIX,1,2,1,-1);  // 1x2 figur  
	SetDrawWindow("log-linreg");
	ShowDrawWindow();
//	SaveDrawWindow("loglinreg.eps");

	println("*********************lin-log spesifikasjon******************");
	
	olsc(Y,1~log(X),&b);							//lagrer parameterestimatene i vektoren b										
	print( "%c", {"estimat"},
	           "%r", {"konstantledd", "stigningstall"}, b );


// Lager figur
	SetDraw(SET_DEFAULT);							//resets defaults
	SetDraw(SET_XYSTYLE,1);							//labels along axes
	DrawX(0,Y',log(X)');
	DrawX(1,Y',X');
	DrawAxisAuto(0,TRUE);
	DrawAdjust(ADJ_AXISLINE,FALSE,-1,-1,-1); //ingen linje nr Y=0
	//den estimerte modellen
	pred = (1~log(X))*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	preds = sortbyc(pred~log(X),1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
	//den estimerte modellen i nivvariabler
	predniv = (1~log(X))*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	prednivs = sortbyc(pred~X,1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
		
	//tegner inn den estimerte modellen
	DrawXMatrix(0,preds[][0]',"$Y$",preds[][1]',"$lnX$",0,1);
	DrawXMatrix(1,prednivs[][0]',"$Y$",prednivs[][1]',"$X$",0,1);	
	DrawAdjust(ADJ_AXISLABEL,1,0,-1,1);
	DrawAdjust(ADJ_AREAMATRIX,1,2,1,-1);  // 1x2 figur 
	SetDrawWindow("lin-logreg");
	ShowDrawWindow();
//	SaveDrawWindow("linlogreg.eps");
	
	println("*********************invers x spesifikasjon******************");
	
	olsc(Y,1~(X.^(-1)),&b);							//lagrer parameterestimatene i vektoren b										
	print( "%c", {"estimat"},
	           "%r", {"konstantledd", "stigningstall"}, b );


// Lager figur
	SetDraw(SET_DEFAULT);							//resets defaults
	SetDraw(SET_XYSTYLE,1);							//labels along axes
	DrawX(0,Y',(X.^(-1))');
	DrawX(1,Y',X');
	DrawAxisAuto(0,TRUE);
	DrawAdjust(ADJ_AXISLINE,FALSE,-1,-1,-1); //ingen linje nr Y=0
	//den estimerte modellen i nivvariabler
	pred = (1~(X.^(-1)))*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	preds = sortbyc(pred~X.^(-1),1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
	predniv = (1~(X.^(-1)))*b;
	//sorterer data etter stigende arbeidsledighet, for  trekke en linje mellom punktene
	prednivs = sortbyc(pred~X,1); //sorterer etter kolonne med indeks 1 --- frste kolonne har indeks 0
		
	//tegner inn den estimerte modellen
	DrawXMatrix(0,preds[][0]',"$Y$",preds[][1]',"$1/X$",0,1);
	DrawXMatrix(1,prednivs[][0]',"$Y$",prednivs[][1]',"$X$",0,1);	
	DrawAdjust(ADJ_AXISLABEL,1,0,-1,1);
	DrawAdjust(ADJ_AREAMATRIX,1,2,1,-1);  // 1x2 figur 	SetDrawWindow("invx");
	ShowDrawWindow();
//	SaveDrawWindow("invxreg.eps");
	
}
