/*
Popfunks kap3.ox
Lager figurene for log-log, log-lin, lin-log, og inverse
funksjoner i kapittel 3
*/

#include <oxstd.h>
#include <oxdraw.h>

main()
{
decl y, loglogy, logliny, linlogy, invx, invy, x, invxasy;
// Lager frst data for x som gr fra 1 til 100
x = range(1,100)'./100;
SetDraw(SET_DEFAULT);							//resets defaults
SetDraw(SET_XYSTYLE,1);
SetDraw(SET_BOX, 1, 0, 0);

//Lag grafen av log-log modellen
	// CobbDouglas
	y = 5.*(x.^.2);
	// grafen
	DrawXMatrix(0, y',"Y" , x',"X", 0,1);
	//lag tekst i grafen
	DrawText(0,"$Y=5X^{0.2}$", 0.4, 3);
	//graf av log-log modell
	DrawXMatrix(1, log(y)',"lnY" , log(x)',"lnX", 0,1);
	//lag tekst i grafen
	DrawText(1,"$Y=ln(5) + 0.2ln(X)$", -4.6, 1.4);
	//set 1 x 2 graf
	DrawAdjust(ADJ_AREAMATRIX, 1, 2);
	SetDrawWindow("log-log");
	ShowDrawWindow();
	SaveDrawWindow("loglog.eps");
	

//lag grafen av semilog modellen
	logliny = exp(.5 + .9.*x);
	linlogy = .5 + .9.*log(x);
	//log-lin grafen
	DrawXMatrix(0, logliny',"Y" , x',"X", 0,1);
	//lag tekst i grafen
	DrawText(0,"$ln(Y)=0.5 + 0.9X$", 0.3, 3.5);
	//graf av log-log modell
	DrawXMatrix(1, linlogy',"Y" , x',"X", 0,1);
	//lag tekst i grafen
	DrawText(1,"$Y= 0.5 + 0.9ln(X)$", 0.4, -2);
	//set 1 x 2 graf
	DrawAdjust(ADJ_AREAMATRIX, 1, 2);
	SetDrawWindow("semilog");
	ShowDrawWindow();
	SaveDrawWindow("semilog.eps");

//lag grafen av inversmodellen
	x = range(-100,100)'./10;
	invx = 5 + .2./x;
	invy = (.1 + 2.*x).^(-1);
	invxasy=constant(5,100,1);
	//log-lin grafen
	DrawXMatrix(0, (invx)',"Y" , x',"X", 0,1);
	//lag tekst i grafen
	DrawText(0,"$Y=5 + 0.2(1/X)$", -9.6, 6);
	//graf av log-log modell
	DrawXMatrix(1, invy',"Y" , x',"X", 0,1);
	//lag tekst i grafen
	DrawText(1,"$(1/Y)= 0.1 + 2X$", -9.7, 5);
	//set 1 x 2 graf
	DrawAdjust(ADJ_AREAMATRIX, 1, 2);
	SetDrawWindow("invers");
	ShowDrawWindow();
	SaveDrawWindow("invers.eps");
}
